.nolist
include masm32rt.inc
include debug.inc
includelib debug.lib
.586
inv equ invoke
.list
.data
ClassName DB "StdWindow",0
AppName   DB "test settimer",0
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,COLOR_WINDOW+1,0,ClassName>
.data?
hInst   dd ?
hWindow dd ?
hWin    dd ?
hwindow dd ? 
message MSG <>
.code
Program:
    inv GetModuleHandle, 0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    inv LoadIcon,0, IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass, addr wc
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW,
           10,10,10,10,0,0,hInst,0
    mov hWindow,eax
    inv ShowWindow, hWindow, SW_SHOWNORMAL
    inv UpdateWindow, hWindow
    .repeat
        inv GetMessage,addr message,0,0,0
        .break .if !eax
        inv TranslateMessage,addr message
        inv DispatchMessage,addr message
    .until 0
    inv ExitProcess,message.wParam

.data
hpfreq  dq ?    ; high performance counter frequency
fstcnt  dq ?    ; starting timer count
endcnt  dq ?    ; ending timer count
tdelay  dd ?    ; multimedia timer delay wanted
tgot    dd ?    ; actual delay that occured
terr    dd ?
tcode   dd ?
tflag   dd ?
lcnt    dd ?
.data
t1000   dq 1000

.data?
buffx dd 100 dup (?)
mbuff equ offset buffx
rowcnt dd ?
.code
WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .if uMsg==WM_CREATE
        mov eax,hWnd
        mov hWin,eax  ; good from now on
        mov lcnt,10
        mov rowcnt,1
        call WaitTest   ; call first one
    .elseif uMsg==WM_USER
        mov eax,tdelay
        sub eax,tgot
        mov terr,eax
        inv wsprintf,mbuff,SADD("Wanted %3li ms.  Got %3li ms.  Error= %3li ms.  "),tdelay,tgot,terr
        DBGWIN_EXT_INFO = 0
        inv DebugPrint,mbuff
        add rowcnt,20
        dec lcnt
        .if zero?
            inv ExitProcess,0
        .endif
        call WaitTest
    .endif
    inv DefWindowProc, hWnd, uMsg, wParam, lParam
WndRet:
    ret
WndProc EndP
TimerProc proc hwnd,imsg,tid,ctime  ; timer callback routine.
    inv QueryPerformanceCounter,addr endcnt
    inv QueryPerformanceFrequency,addr hpfreq
    finit
    fild endcnt
    fild fstcnt
    fsub
    fwait
    fild hpfreq
    fdiv
    fild t1000
    fmul
    fist tgot
    mov tflag,0
    inv KillTimer,hWin,tid
    inv PostMessage,hWin,WM_USER,0,0    
	ret
TimerProc endp
WaitTest proc
    rdtsc
    and eax,127
    mov tdelay,eax
	inv QueryPerformanceCounter,addr fstcnt
    inv SetTimer,hWin,9999,tdelay,addr TimerProc
    mov tflag,1
	ret
WaitTest endp

End Program